/*
Program: poly-integer-root-llist.c (Report comments/bugs to chikh@yuntech.edu.tw)
Function: phƮڡA{LJhAXGJhH̺²Φe{
	(YƻPƭY1iٲ)ABܸѱoƮڡFYƮڤsbAhܰTi
Note: {LJΦi 
	1x^2-100x^0
	1x^3-2x^2-1x^1+2x^0
	1x^3-7x^2+4x^1+12x^0
	1x^4+3x^3-66x^2+52x^1+120x^0
	3x^4+9x^3-198x^2+156x^1+360x^0
	1x^2-1x^1
	
	1x^3-2x^2-5x^1+6x^0
	1x^2-1x^1-2x^0
	-3x^2+3x^1+6x^0
	1x^5-10000x^3
*/

#include <stdio.h>
#include <stdlib.h>	/* for malloc() */
#include <math.h>	/* for pow() */

typedef struct term term;
struct term {
	int coef;	/* Y */ 
	int exp;	/*  */
	term *next;	/* U@ */
} *tail, p, q, t; /* pNĤ@ӦhBqĤGӦhBtGӦhn */ 

void compact(char str[]) /* strťաAܱo */ 
{
    int i, j;
    
    for (i = j = 0; str[i]; i++, j++) {
    	for (; str[i]==' '; i++);
    	str[j] = str[i];
	}
	str[j] = '\0';
}

void readPoly(term *poly)	/* ŪJB⦡rAUƻPYƤOxs}CA^ǫDsӼ */ 
{
	int  i = 0, argCount, a, b, highestExp = -1000;
	char str[256];
	
	tail = poly;
	
	gets(str); 	  /* ĳ fgets(str,MAX,stdin) HקKyJƹLӳyLwİzͿ~ */ 
	compact(str); /* strťաAܱo */ 
	
	do { 
    	argCount = sscanf(str,"%dx^%d%s",&a,&b,str);
		tail = tail->next = (term *)malloc(sizeof(term));
		tail->coef = a;
		tail->exp = b;
		i++;
		if (a > highestExp) highestExp = a;
      	if (argCount==2) break; /* Wsscanf()qstruŪ2ӼƾڡA, A]SFi(sJstr)ANrwŪɡANj */
  	} while (1); 
  	
	tail->next = NULL;
	
	poly->coef = i;			/* C`IcoefӦh@hֶ */ 
	poly->exp = highestExp;	/* C`IexpӦh̰ƭ */
}

void multiplyPoly(term *p, term *q)	
{	
	int i, count, highestExp = -1000, *mult;
	term *ptr1, *ptr2;
	
	//mult = (int *)malloc((p->exp+q->exp+1)*sizeof(int));
	mult = (int *)calloc(p->exp+q->exp+1,sizeof(int)); /* calloc()ist쪺}CŶM0F`Nϥcalloc()ykPmalloc()yP */ 
	for (ptr1 = p->next; ptr1; ptr1 = ptr1->next) 
		for (ptr2 = q->next; ptr2; ptr2 = ptr2->next) 
			mult[ptr1->exp+ptr2->exp] += ptr1->coef*ptr2->coef;
				
	tail = &t;
	for (i = p->exp+q->exp, count = 0; i >= 0; i--) 
		if (mult[i] != 0) {
			tail = tail->next = (term *)malloc(sizeof(term));
			tail->coef = mult[i];
			tail->exp = i;
			count++;
			if (i > highestExp) highestExp = i;
		}
	tail->next = NULL;
	
	t.coef = count;		/* tC`IcoefӦh@h֫Ds */ 
	t.exp = highestExp;	/* tC`IexpӦh̰ƭ */
}

int findRoot(term *poly, int root[]) /* ڡAұoѦsJroot[]A^ǮڪӼ */ 
{
	int r, c = 0, i, j, sum;
	int sign[2] = {1,-1};
	term *ptr;
	
	if ((tail->exp) != 0) { /* ̧C >= 1Ah0i */ 
		if ((i=tail->exp) > 0) root[c++] = 0;
		for (ptr = poly; ptr; ptr = ptr->next) ptr->exp -= i;
	}
	if (tail->coef%poly->coef != 0) return c;	/* ̥YƤQ̰Yƾ㰣AhsbƸ */ 
	
	r = abs(tail->coef/poly->coef);	/* WƫA̰YƬ1ḀYƬr */ 
	for (i = 1; i <= r; i++) {		/* Ҽ{㰣r]iA`Nt */ 
		if (r%i != 0) continue;		/* 㰣riNLA~Ҽ{U@i */ 
		for (j = 0; j < 2; j++) {	/* j0ANҼ{+iҡFj1ANҼ{-ip */
			for (sum = 0, ptr = poly; ptr; ptr = ptr->next)	/* pC@G(Y*x^)ò֥[sum */ 
				sum += ptr->coef*(int)(pow(sign[j]*i,ptr->exp));
			if (sum == 0) root[c++] = sign[j]*i;  /* bingo! o{XG󪺾ƮڡANgJq}C */ 
		}
	}
	
	return c;
}

void show(term *poly)
{	
	term *ptr = poly;
	
	printf("\n{t(x)= ");
	for (; ptr; ptr = ptr->next) {
		if (abs(ptr->coef)>1) 	/* Y>1<-1AhܸӫYƭ */ 
			printf("%s%d",ptr->coef>1? "":"\b",ptr->coef);	/* YYƬtȡAeɪ+ */ 
		else if (ptr->coef == -1)	/* YƬ-1A-Yi */ 
			printf("%s",ptr->exp==0? "\b-1":"\b-");
		else
			printf("%s",ptr->exp==0? "1":"");
		switch(ptr->exp) {
			case 0: 
				printf("+");
				break;
			case 1:
				printf("x+");
				break;
			default:
				printf("x^%d+",ptr->exp);
		}		
	}
	printf("\b ");	

}

int main()
{
	int i, c, *root; 
	
	printf("\n*** ѤGӦhnƮ ***\n\nJĤ@Ӧh ==> ");
	readPoly(&p);
	printf("\nJĤGӦh ==> ");
	readPoly(&q);
	multiplyPoly(&p,&q);
	show(t.next);
	
	root = (int *)malloc(t.exp*sizeof(int)); /* t.exp̰ơA̦ȳЫبŶ}CsҨDoƮ */ 
	c = findRoot(t.next,root);
	if (c > 0) {
		printf("\n\nѱoƮڬG");
		for (i = 0; i < c; i++) printf("%dB",root[i]);
		printf("\b\b  "); 
	}
	else
		printf("\n\nƮڤsb\n");
	
	free(root);
	/* oAɤW{XApBqPtgmalloc()oOŶ@^OS */ 
	return 0;
}
